function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { createContext, useState, useContext } from 'react';
import { createPortal } from 'react-dom';
import { Spin } from 'rlj-design';
import { PREFIX_CLS } from "../constants";
import "./index.less";
/**
 * @description 全屏loading，通过使用useFullLoading() 函数，返回open打开，close关闭方法
 * @param
 * @returns
 * */

import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var prefix_cls = "".concat(PREFIX_CLS, "-full-loading");
var FullLoadingContext = /*#__PURE__*/createContext({
  open: function open() {},
  close: function close() {}
});
var tipText = '正在导出中，稍等一下，喝杯茶吧~';
export function FullLoadingProvider(_ref) {
  var children = _ref.children;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var _useState3 = useState(tipText),
      _useState4 = _slicedToArray(_useState3, 2),
      tip = _useState4[0],
      setTip = _useState4[1];

  var handleOpen = function handleOpen(_ref2) {
    var tip = _ref2.tip;
    setOpen(true);
    tip && setTip(tip);
  };

  var handleClose = function handleClose() {
    setOpen(false);
    setTip(tipText);
  };

  var val = {
    open: handleOpen,
    close: handleClose
  };
  return /*#__PURE__*/_jsxs(FullLoadingContext.Provider, {
    value: _objectSpread({}, val),
    children: [children, open && /*#__PURE__*/createPortal( /*#__PURE__*/_jsx(Spin, {
      spinning: true,
      tip: tip,
      wrapperClassName: prefix_cls + '-antSpin',
      children: /*#__PURE__*/_jsx("div", {
        className: prefix_cls + '-content'
      })
    }), document.body)]
  });
}
export function useFullLoading() {
  return useContext(FullLoadingContext);
}